(* EPITA SPE 2010/2011        *)
(* Contrôle 1 - Novembre 2010 *)
(* question08                 *)

type s_list =
{
  mutable value : int;
  mutable next  : s_list option;
}

type t_list =
{
  mutable head : s_list option;
  mutable size : int;
}

let create () =
{
  head = None;
  size = 0;
}

let is_empty l = l.size = 0

let size l = l.size

let add x l =
  let cell =
    {
      value = x;
      next = l.head;
    }
  in
    l.head <- Some cell;
    l.size <- l.size + 1

let drop_head l =
  match l.head with
    | None -> ()
    | Some cell ->
	l.head <- cell.next;
	l.size <- l.size - 1

let get_head l =
  match l.head with
    | None -> assert false
    | Some cell -> cell.value

let iter f l =
  let cell = ref l.head in
    while !cell <> None do
      match !cell with
	| None -> assert false
	| Some c ->
	    f c.value;
	    cell := c.next
    done
