(* EPITA SPE 2010/2011        *)
(* Contrôle 1 - Novembre 2010 *)
(* question10                 *)

type value =
  | Int of int
  | Float of float

type expr =
  | Val of value
  | Var of string
  | Op of expr * string * expr
  | Let of string * expr * expr

module Env = Map.Make(String)

let rec eval openv env = function
  | Val v -> v
  | Var x -> Env.find x env
  | Op(e1,o,e2) ->
      begin
	match (eval openv env e1, eval openv env e2) with
	  | (Int i1, Int i2) -> Int ((fst (Hashtbl.find openv o)) i1 i2)
	  | (Float i1, Float i2) ->
	      Float ((snd (Hashtbl.find openv o)) i1 i2)
	  | (Float f, Int i) ->
	      Float ((snd (Hashtbl.find openv o)) f (float i))
	  | (Int i, Float f) ->
	      Float ((snd (Hashtbl.find openv o)) (float i) f)
      end
  | Let(x,e1,e2) ->
      eval openv (Env.add x (eval openv env e1) env) e2
