(* EPITA SPE 2010/2011        *)
(* Contrôle 1 - Novembre 2010 *)
(* question10 - test          *)

module Q = Question10

let pretty_val = function
  | Q.Int i -> Format.printf "%d" i
  | Q.Float f -> Format.printf "%f" f

let rec pretty_print = function
    Q.Var x -> Format.printf "%s" x
  | Q.Val v -> pretty_val v
  | Q.Op(e1,o,e2) ->
      begin
	Format.printf "@[<b 2>(@,";
	pretty_print e1;
	Format.printf "@;%s " o;
	pretty_print e2;
	Format.printf ")@]"
      end
  | Q.Let(x,e1,e2) ->
      begin
	Format.printf "@[<b 2>let %s =@;" x;
	pretty_print e1;
	Format.printf "@;in@;";
	pretty_print e2;
	Format.printf "@]";
      end

let openv = Hashtbl.create 5
let _ =
  List.iter (fun (o,io,fo) -> Hashtbl.add openv o (io,fo))
    [
      ("+",(+),(+.));
      ("-",(-),(-.));
      ("*",( * ),( *.));
      ("/",(/),(/.));
    ]

let main () =
  begin
    let q = new Test_frame.qFile 10 in
      q#beginParse;
      let e =
	Parser.main Lexer.token (Lexing.from_channel q#getChan)
      in
	Format.printf "@[<v 2>e =@;";
	pretty_print e;
	Format.printf "@]@.";
	Format.printf "@[<b 2>e =@;";
	pretty_val (Q.eval openv Q.Env.empty e);
	Format.printf "@]@.";
  end

let _ = main ()
